// $Id: checksyntax-int.hc,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

static bool
checkSyntax_int(struct SyntaxInfo *syntax,
		char const *str, char const **reason)
{
  char	*errptr;
  int	res = strtol(str, &errptr, 10);
  if (errptr==0 || *errptr!='\0') {
    *reason = "Not a number";
    return false;
  }

  if (syntax->info.i.min > res || res >= syntax->info.i.max) {
    *reason = "Number out of range";
    return false;
  }

  return true;
}

static bool
checkSyntax_uint(struct SyntaxInfo *syntax,
		 char const *str, char const **reason)
{
  char		*errptr;
  unsigned long	res = strtol(str, &errptr, 10);
  if (errptr==0 || *errptr!='\0') {
    *reason = "Not a number";
    return false;
  }

  if (syntax->info.u.min > res || res >= syntax->info.u.max) {
    *reason = "Number out of range";
    return false;
  }

  return true;
}
