// $Id: daemonize.hc,v 1.2 2003/11/07 00:45:05 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "util-io.h"
#include "wrappers.h"
#include "wrappers-io.h"

inline static int
daemonize(struct ArgInfo const *args)
{
  int		fd[2];
  Epipe(fd);

  pid_t		pid = Efork();
  switch (pid) {
    case 0	:
    {
      Eclose(0);
      Eclose(fd[0]);
      Esetsid();
      pid = Efork();
      if (pid!=0) _exit(0);

      pid = getpid();

      int	log_fd = Eopen(args->log_file, O_CREAT|O_APPEND|O_WRONLY, 0600);
      int	err_fd = Eopen(args->err_file, O_CREAT|O_APPEND|O_WRONLY, 0600);
      
      Edup2(log_fd, 1);
      Edup2(err_fd, 2);

      Eclose(err_fd);
      Eclose(log_fd);

      if (args->pid_file!=0) {
	int	pid_fd = Eopen(args->pid_file, O_CREAT|O_WRONLY, 0644);
	writeInt(pid_fd, pid);
	WRITE_MSG(pid_fd, "\n");
	Eclose(pid_fd);
      }
      
      return fd[1];
    }

    default	:
      Eclose(fd[1]);
      if (!EreadAll(fd[0], &pid, sizeof pid)) _exit(1);

      _exit(0);
  }
}
