// $Id: util-io.h,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c++ -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNI_SRC_UTIL_IO_H
#define H_VSERVER_DJINNI_SRC_UTIL_IO_H

#include "wrappers.h"

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdbool.h>

inline static void UNUSED
writeStr(int fd, char const *cmd)
{
  (void)write(fd, cmd, strlen(cmd));
}

#define WRITE_MSG(FD,X)		(void)(write(FD,X,sizeof(X)-1))
#define WRITE_STR(FD,X)		writeStr(FD,X)

void	writeInt(int fd, int val);

struct ucred;
bool	readCreds(int fd, void *buf, size_t buf_len, struct ucred *cred);

inline static void
setCloseOnExec(int fd)
{
  int	flag;

  if ((flag=fcntl(fd, F_GETFD))==-1 ||
      fcntl(fd, F_SETFD, flag | FD_CLOEXEC)==-1) {
    perror("fcntl()");
    exit(1);
  }
}

inline static bool
touch(char const *pathname)
{
  int		fd;

  return ((fd=open(pathname, O_CREAT|O_EXCL|O_WRONLY, 0644))!=-1 &&
	  close(fd)!=-1);
}

inline static void
Etouch(char const *pathname)
{
  FatalErrnoError(!touch(pathname), "touch()");
}

inline static void
Xclose(int fd)
{
  if (fd!=-1) close(fd);
}

inline static void
XXclose(int *fd)
{
  if (*fd!=-1) {
    (void)close(*fd);
    *fd = -1;
  }
}

#endif	//  H_VSERVER_DJINNI_SRC_UTIL_IO_H
